﻿namespace DocuMed.Domain.Entities.MedicalHistory;


public partial class MedicalHistoryAnswer
{
    public static MedicalHistoryAnswer Create(
        string answer,
        string question,
        MedicalHistoryPart part,
        MedicalHistoryQuestionType questionType,
        Guid medicalHistoryId)
    {
        return new MedicalHistoryAnswer(answer, question, part, questionType, medicalHistoryId);
    }
}
public partial class MedicalHistory
{
    public MedicalHistoryAnswer AddAnswer(string answer, string question, MedicalHistoryPart part, MedicalHistoryQuestionType questionType)
    {
        var mhAnswer = MedicalHistoryAnswer.Create(answer, question, part, questionType, Id);
        Answers.Add(mhAnswer);
        return mhAnswer;
    }
    public static MedicalHistory Create(
        string chiefComplaint,
        string section,
        string firstName,
        string lastName,
        string fatherName,
        string nationalId,
        int age,
        DateTime birthDate,
        string presentIllnessDetail,
        string pastDiseasesHistoryDetail,
        string pastSurgeryHistoryDetail,
        string familyHistoryDetail,
        string allergyDetail,
        string drugHistoryDetail,
        string addictionHistoryDetail,
        string systemReviewDetail,
        string vitalSignDetail,
        int systolicBloodPressure,
        int diastolicBloodPressure,
        int pulseRate,
        int sPO2,
        int temperature)
    {
        return new MedicalHistory(presentIllnessDetail,
            pastDiseasesHistoryDetail,
            pastSurgeryHistoryDetail,
            familyHistoryDetail,
            allergyDetail,
            drugHistoryDetail,
            addictionHistoryDetail,
            systemReviewDetail,
            vitalSignDetail,
            chiefComplaint, section, firstName, lastName, fatherName, nationalId, age, birthDate, systolicBloodPressure,
            diastolicBloodPressure, pulseRate, sPO2, temperature);
    }

}