﻿namespace DocuMed.Domain.Entities.MedicalHistory;

[AdaptTwoWays("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[GenerateMapper]
public partial class MedicalHistoryAnswer : ApiEntity
{
    public MedicalHistoryAnswer()
    {
        
    }

    public MedicalHistoryAnswer(
        string answer,
        string question,
        MedicalHistoryPart part, 
        MedicalHistoryQuestionType questionType, 
        Guid medicalHistoryId)
    {
        Answer = answer;
        Question = question;
        Part = part;
        QuestionType = questionType;
        MedicalHistoryId = medicalHistoryId;
    }
    public string Answer { get; internal set; } = string.Empty;
    public string Question { get; internal set; } = string.Empty;
    public MedicalHistoryPart Part { get; internal set; }
    public MedicalHistoryQuestionType QuestionType { get; internal set; }

    public Guid MedicalHistoryId { get; internal set; }
    public MedicalHistory? MedicalHistory { get; internal set; }
}