﻿namespace DocuMed.Domain.Entities.MedicalHistoryTemplate;

[AdaptTwoWays("[name]SDto", IgnoreAttributes = new[] { typeof(AdaptIgnoreAttribute) }, MapType = MapType.Map | MapType.MapToTarget | MapType.Projection)]
[GenerateMapper]
public partial class MedicalHistoryQuestion : ApiEntity
{
    public MedicalHistoryQuestion()
    {
        
    }

    public MedicalHistoryQuestion(
        string question,
        MedicalHistoryPart part,
        MedicalHistoryQuestionType questionType,
        Guid medicalHistoryTemplateId)
    {
        Question = question;
        Part = part;
        QuestionType = questionType;
        MedicalHistoryTemplateId = medicalHistoryTemplateId;
    }

    public string Question { get; internal set; } = string.Empty;
    public MedicalHistoryPart Part { get; internal set; }
    public MedicalHistoryQuestionType QuestionType { get; internal set; }

    public Guid MedicalHistoryTemplateId { get; internal set; }
    public MedicalHistoryTemplate? MedicalHistoryTemplate { get; internal set; }
}